//recover mana
#include "WizardCommon.as";
u8 manaRegenerateStep = 2;
s32 playersCount = 0;

void onInit(CBlob@ this)
{
	this.getCurrentScript().tickFrequency = 1 * getTicksASecond();
	this.getCurrentScript().removeIfTag = "dead";
}

void onTick(CBlob@ this)
{
	WizardInfo@ wiz;
    if (!this.get( "wizardInfo", @wiz )) {
        return;
    }
    s32 mana = wiz.mana;
    s32 maxMana = wiz.maxMana;
    if (mana < maxMana)
    {
    	if (maxMana - mana >= manaRegenerateStep)
    		wiz.mana += manaRegenerateStep;
    	else
    		wiz.mana = maxMana;
    }
}

void adjustManaRegenStepToPlayersAmount()
{
    CBlob@[] player_blobs;
    getBlobsByTag( "player", @player_blobs );

    uint wizards = 0;
    uint survivors = 0;
 
    for(uint i=0; i<player_blobs.length; i++ ){
        if (player_blobs[i] !is null){
            if (player_blobs[i].getTeamNum() == 0)
                survivors++;
            else if (player_blobs[i].getTeamNum() == 1)
                wizards++;
        }
    }
    if (wizards > 0)
        manaRegenerateStep = survivors / wizards;
    playersCount = wizards + survivors;
}